SystemOrganization addCategory: #'rfb-patch'!

!RFBServer methodsFor: '*rfb-patch' stamp: 'sebastian.sastre 12/4/2009 16:40'!
port: anInteger

	port := anInteger! !

!RFBServer methodsFor: '*rfb-patch' stamp: 'sebastian.sastre 12/5/2009 12:13'!
start

	self log: 'start'.
	
	"Reset the log on start"
	RFBLog resetLog.
	
	"Reset the session registry"
	sessions := IdentitySet new.
	sessionsSema := Semaphore forMutualExclusion.
	
	"Replace the display for a RFB enabled one"
	self installDisplay.

	"Start the server"	
	port ifNil:[
		self error: 'Can''t start RFB server without specifying a port to listen'].
	socket := RFBSocket newTCP.
	socket listenOn: port backlogSize: 5.
	socket isValid ifFalse: [^self error: 'Could not create RFB server socket'].
	process := [self runLoop] forkAt: self serverPriority named: 'rfb'.
	isRunning := true.
		
	self log: 'started'! !

!RFBSocket class methodsFor: '*rfb-patch' stamp: 'sebastiansastre 10/26/2013 10:40'!
requestHostAndDisplay: promptString
	"Request and parse an address in the form 'hostname' or 'hostname:<dpy>'.  Answer an array containing the host name and display number, or nil if there was a problem."
	"RFBSocket requestHostAndDisplay: 'test me?'"

	| display hostName hostAndDisplay |
	(hostAndDisplay := UIManager default request: promptString initialAnswer: LastServerAddress) isEmptyOrNil ifTrue: [^nil].
	hostAndDisplay := hostAndDisplay findTokens: $:.
	(hostAndDisplay size < 1 or: [hostAndDisplay size > 2])
		ifTrue:
			[self inform: 'I could not parse that address.  Use: hostname[:<displayNumber>]'.
			 ^nil].
	hostName := hostAndDisplay first trimBoth.
	display := hostAndDisplay size == 2
		ifTrue: [hostAndDisplay second trimBoth asInteger]
		ifFalse: [0].
	display isNil
		ifTrue:
			[self inform: 'I could not parse the display number.'.
			 ^nil].
	LastServerAddress := hostName , ':' , display printString.
	^Array with: hostName with: display! !
